vector<string> exportFormatList=vector<string>();
vector<string> exportExtensionList=vector<string>();
int exportFormatCount;
int exportFormatCursor=0;



void clear_export_format(void)
{
	exportFormatList.clear();
	exportExtensionList.clear();

	exportFormatCount=0;
}



void add_export_format(string &name,string &ext)
{
	exportFormatList.push_back(name);
	exportExtensionList.push_back(ext);

	++exportFormatCount;
}



void set_export_data(void)
{
	if(exportFormatCursor>=exportFormatCount) exportFormatCursor=exportFormatCount-1;

	set_edit_mode(MODE_EXPORT_DATA);
}



void draw_export_data(void)
{
	for (int i = 0; i < textScreenWidth; ++i)
	{
		PUT_ATTR(i,0,COL_HEADER);
		PUT_ATTR(i,textScreenHeight-1,COL_HEADER);
	}

	put_str(1,0,"Export song data",COL_HEADER);

	unsigned int maxlen = 0;

	for (int i = 0; i < exportFormatCount; ++i)
	{
		if(exportFormatList[i].length()>maxlen) maxlen=exportFormatList[i].length();
	}

	int y = PATTERN_YPOS + 1;

	for (int i = 0; i < exportFormatCount; ++i)
	{
		put_str(PATTERN_XPOS + 1, y, (char*)(" " + exportFormatList[i] + " ").c_str(), (i == exportFormatCursor) ? COL_CURSOR_ROW : COL_PROGRAM_BACKGROUND);
		put_str(PATTERN_XPOS + 4 + maxlen, y, (char*)("(*." + exportExtensionList[i] + ")").c_str(), COL_PROGRAM_BACKGROUND);

		++y;
	}
}



void export_data_events(SDL_Event event)
{
	switch(event.type)
	{
	case SDL_KEYDOWN:
		{
			switch(event.key.keysym.sym)
			{
			case SDLK_ESCAPE:
				{
					set_edit_mode(MODE_EDIT_SONG);
				}
				break;

			case SDLK_UP:
				{
					--exportFormatCursor;

					if(exportFormatCursor<0) exportFormatCursor=exportFormatCount-1;
				}
				break;

			case SDLK_DOWN:
				{
					++exportFormatCursor;

					if(exportFormatCursor>=exportFormatCount) exportFormatCursor=0;
				}
				break;

			case SDLK_PAGEUP:
			{
				exportFormatCursor = 0;
			}
			break;

			case SDLK_PAGEDOWN:
			{
				exportFormatCursor = exportFormatCount - 1;
			}
			break;

			case SDLK_RETURN:
				{
					music_stop();

					if (compile_song(exportFormatCursor + 1, 0, false, false, false))
					{
						if(scriptGeneratedData1&&scriptGeneratedData1Size)
						{
							set_select_file("Export data file", exportDirectory, sizeof(exportDirectory), MODE_EDIT_SONG, ("." + exportExtensionList[exportFormatCursor]).c_str(), true, EVENT_EXPORT_DATA_FILE, selectFileImportLast, sizeof(selectFileImportLast), 1, 0);
						}
					}
				}
				break;
			}
		}
		break;
	}
}