int infoCursor = 0;
string infoExtra;
string infoDocFile;
char* infoText = NULL;
int infoWidth;
int infoHeight;
int infoLines = 0;
int infoLineCur = 0;



void set_info(void)
{
	infoWidth = textScreenWidth - 4;
	infoHeight = textScreenHeight - (PATTERN_YPOS + 15) - 1;

	set_edit_mode(MODE_INFO);

	//compile song to get extra info if available

	music_stop();

	script_run(engineFileName, "Info");

	if (compile_song(0, 0, false, false, false))
	{
		script_free_data1();
	}

	if (infoText)
	{
		free(infoText);
		infoText = NULL;
		infoLines = 0;
		infoLineCur = 0;
	}

	if (infoDocFile != "")
	{
		string path = baseDirectory;
		path = path + "docs/engines/" + infoDocFile;

		FILE* file = xfopen(path.c_str(), "rt");

		if (file)
		{
			xfseek(file, 0, SEEK_END);
			int size = xftell(file) + 16;
			xfseek(file, 0, SEEK_SET);

			infoText = (char*)malloc(size);

			memset(infoText, 0, size);

			xfread(infoText, size, 1, file);
			xfclose(file);

			for (int i = 0; i < 15; ++i) strcat(infoText, "\n");

			infoLines = count_str_wrap_lines(infoWidth, infoHeight, infoText);
			infoLineCur = 0;
		}
	}
}



const char* get_engine_name(void);

void draw_info(void)
{
	for (int i = 0; i < textScreenWidth; ++i)
	{
		PUT_ATTR(i, 0, COL_HEADER);
		PUT_ATTR(i, textScreenHeight - 1, COL_HEADER);
	}

	for (int i = 0; i < 13; ++i)
	{
		for (int j = 0; j < textScreenWidth; ++j)
		{
			PUT_ATTR(j, PATTERN_YPOS + i, COL_PATTERN_BEAT);
		}
	}

	put_str(1, 0, "Information", COL_HEADER);

	put_str(PATTERN_XPOS + 1, PATTERN_YPOS + 1, "Song title:", (infoCursor == 0) ? COL_CURSOR_ROW : COL_PATTERN_BEAT);
	put_str(PATTERN_XPOS + 14, PATTERN_YPOS + 1, module.title, COL_PATTERN_BEAT);

	put_str(PATTERN_XPOS + 1, PATTERN_YPOS + 3, "Song author:", (infoCursor == 1) ? COL_CURSOR_ROW : COL_PATTERN_BEAT);
	put_str(PATTERN_XPOS + 14, PATTERN_YPOS + 3, module.author, COL_PATTERN_BEAT);

	put_str(PATTERN_XPOS + 1, PATTERN_YPOS + 6, "Engine:", COL_PATTERN_BEAT);
	put_str(PATTERN_XPOS + 9, PATTERN_YPOS + 6, get_engine_name(), COL_PATTERN_BEAT);

	put_str_wrap(PATTERN_XPOS + 1, PATTERN_YPOS + 9, textScreenWidth - 2, PATTERN_HEIGHT / 2 - 1, infoExtra.c_str(), COL_PATTERN_BEAT, 0);

	if (infoText)
	{
		put_str(1, textScreenHeight - 1, "Use ~PgUp/PgDown~ to scroll the doc", COL_HEADER);

		put_str_wrap(PATTERN_XPOS + 3, PATTERN_YPOS + 15, infoWidth, infoHeight, infoText, COL_PROGRAM_BACKGROUND, infoLineCur);

		if (infoLineCur > 0)
		{
			PUT_CHAR_ATTR(PATTERN_XPOS + 1, PATTERN_YPOS + 15, 16, COL_DIRECTORY);
			PUT_CHAR_ATTR(PATTERN_XPOS + 1, PATTERN_YPOS + 16, 16, COL_DIRECTORY);
		}

		if ((infoLineCur + infoHeight) < infoLines)
		{
			PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 3, 17, COL_DIRECTORY);
			PUT_CHAR_ATTR(PATTERN_XPOS + 1, textScreenHeight - 4, 17, COL_DIRECTORY);
		}
	}
	else
	{
		put_str_wrap(PATTERN_XPOS + 3, PATTERN_YPOS + 15, infoWidth, infoHeight, "(no doc file)", COL_DIRECTORY, infoLineCur);
	}
}



void info_events(SDL_Event event)
{
	switch (event.type)
	{
	case SDL_KEYDOWN:
	{
		switch (event.key.keysym.sym)
		{
		case SDLK_ESCAPE:
		{
			set_edit_mode(MODE_EDIT_SONG);
		}
		break;

		case SDLK_UP:
		case SDLK_DOWN:
		{
			infoCursor ^= 1;
		}
		break;

		case SDLK_RETURN:
		{
			switch (infoCursor)
			{
			case 0: set_input_string(PATTERN_XPOS + 14, PATTERN_YPOS + 1, 64, MODE_INFO, true, module.title, NULL); break;
			case 1: set_input_string(PATTERN_XPOS + 14, PATTERN_YPOS + 3, 64, MODE_INFO, true, module.author, NULL); break;
			}
		}
		break;

		case SDLK_PAGEDOWN:
		{
			if (infoLineCur < (infoLines - infoHeight)) ++infoLineCur;
		}
		break;

		case SDLK_PAGEUP:
		{
			if (infoLineCur > 0) --infoLineCur;
		}
		break;
		}
	}
	break;
	}
}