#define LOG_BUF_SIZE	65536
#define LOG_BUF_LINES	3

char logBuf[LOG_BUF_SIZE];

FILE *logFile = NULL;

int logLinesInBuf = 0;


void log_open(const char *name)
{
	logFile = xfopen(name, "wt");

	memset(logBuf, 0, sizeof(logBuf));

	logLinesInBuf = 0;
}



void log_buf_remove_line(void)
{
	for (int i = 0; i < LOG_BUF_SIZE; ++i)
	{
		if (logBuf[i] == '\n')
		{
			for (int j = 0; j < LOG_BUF_SIZE - (i + 1); ++j) logBuf[j] = logBuf[i + 1 + j];

			break;
		}
	}
}



int log_count_lines(char* str)
{
	int cnt = 0;

	for (unsigned int i = 0; i < strlen(str); ++i)
	{
		if (str[i] == '\n') ++cnt;
	}

	return cnt;
}


void log_buf_append(char* str)
{
	strncat(logBuf, str, sizeof(logBuf));
}


void log_add(const char *format, ...)
{
	va_list arg;

	if (!logFile) return;

	va_start(arg, format);
#ifndef WINDOWS
	vprintf(format, arg);
#endif
	vfprintf(logFile, format, arg);
	va_end(arg);

	char buf[LOG_BUF_SIZE];
	va_start(arg, format);
	vsnprintf(buf, sizeof(buf), format, arg);
	va_end(arg);

	while (log_count_lines(logBuf) >= LOG_BUF_LINES) log_buf_remove_line();

	log_buf_append(buf);

	xfflush(logFile);
}



void log_close(void)
{
	if (logFile) xfclose(logFile);
}



char* log_recent(void)
{
	return logBuf;
}